/// <reference path="../types.js" />

/**
 * @param {NavigationGuard[]} queue
 * @param {Function} fn
 * @param {Function} cb
 */
export function runQueue(queue, fn, cb) {
  const step = (/** @type {number} */ index) => {
    if (index >= queue.length) {
      cb();
    } else {
      if (queue[index]) {
        fn(queue[index], () => {
          step(index + 1);
        });
      } else {
        step(index + 1);
      }
    }
  };
  step(0);
}
